define(['require', 'app'],
    function(require, APP) {
        /**
         * Controller for BuscarOrdenes generated by Appery.io
         * @module BuscarOrdenes
         */
        APP.controller('BuscarOrdenes', ['$scope', 'Apperyio', controller]);

        function controller($scope, Apperyio) {
            /**
             * user controller variables
             */
            $scope.ordenesTotal = Apperyio.EntityAPI('Number');
            $scope.orders = Apperyio.EntityAPI('Ordenes');
            $scope.codigoBuscar = Apperyio.EntityAPI('String');
            $scope.marcaBuscar = Apperyio.EntityAPI('String');
            $scope.estadoBuscar = Apperyio.EntityAPI('String');
            $scope.operadorBuscar = Apperyio.EntityAPI('String');
            $scope.markers = Apperyio.EntityAPI('Markers');
            /**
             * User controller functions
             */
            /**
             * @function init
             */
            $scope.init = function() {
                //On load screen logic
                $scope.orders = [];
                $scope.maxDispOrder = 150;
                $scope.ordenesTotal = $scope.orders.length;
                $scope.mostrarMapa = false;
                $scope.textoBotnVerMapa = "Mostrar Mapa";
                $scope.markers = [];
                $scope.datosEmpresa = JSON.parse(localStorage.getItem("companyData"));
                $scope.mOperators = localStorage.getItem("arrayOperators") ? JSON.parse(localStorage.getItem("arrayOperators")) : [];
                $('#inputBuscar').focus();
                $("#inputBuscar").keypress(function(event) {
                    //console.log( "Handler for .keypress() called.: " + event.which);
                    if (event.which == 13) {
                        $scope.buscarOrdenes();
                    }
                });
                $scope.operatorsArrAsoc = {};
                for (var i in $scope.mOperators) {
                    $scope.operatorsArrAsoc[$scope.mOperators[i].codigo] = $scope.mOperators[i].nombre;
                }
            };
            /**
             * @function descargar
             */
            $scope.descargar = function() {
                tableToExcel('dataTable', 'Ordenes');
            };
            /**
             * @function formatDate1
             * @param fecha
             */
            function formatDate1(fecha) {
                if (!fecha) {
                    return fecha;
                }
                var arrFecha = fecha.split(".");
                return arrFecha[2] + "-" + arrFecha[0] + "-" + arrFecha[1];
            };
            /**
             * @function buscarOrdenes
             */
            $scope.buscarOrdenes = function() {
                $scope.showLoading("Buscando...");
                $scope.orders = [];
                $scope.ordenesTotal = $scope.orders.length;
                $scope.markers = [];
                var requestData = {};
                requestData = (function mapping9688($scope) {
                    var requestData = {};
                    requestData.params = {};
                    requestData.params.where = {
                        "$and": [{
                                "companyId": $scope.datosEmpresa.idCliente
                            },
                            ($scope.codigoBuscar) ? {
                                "documentCode": $scope.codigoBuscar
                            } : {},
                            ($scope.marcaBuscar != "0" && $scope.marcaBuscar != "") ? {
                                "productAntecedent.marca": $scope.marcaBuscar
                            } : {},
                            ($scope.estadoBuscar != "0" && $scope.estadoBuscar != "") ? {
                                "documentStatus": parseInt($scope.estadoBuscar)
                            } : {},
                            ($scope.operadorBuscar != "0" && $scope.operadorBuscar != "") ? {
                                "operatorCode": $scope.operadorBuscar
                            } : {},
                            ($scope.fechaBuscar) ? {
                                "assignmentDate": formatDate3($scope.fechaBuscar.toISOString())
                            } : {},
                        ]
                    };
                    requestData.params.limit = $scope.maxDispOrder;
                    requestData.params.sort = "assignmentDate, documentCode";
                    return requestData;
                    /*|button_mapping|onbeforesend|0C90AEF2-D0C1-6BDD-C408-473C557EE902||9688|*/
                })($scope);
                // read more about using rest services: https://links.appery.io/ve-snippet-rest
                Apperyio.get("Tech1_WORKORDER_query_service")(requestData).then( /*|service_bookmark|bookmark|0C90AEF2-D0C1-6BDD-C408-473C557EE902||3904|*/
                    function(success) { // success callback
                        (function mapping1876(success, $scope) {
                            var orders_scope = $scope.orders;
                            for (var i = 0, l = success.data.length; i < l; i++) {
                                _.set(orders_scope, '[' + i + '].codigo', success.data[i].documentCode);
                                _.set(orders_scope, '[' + i + '].estado', $scope.stateList[success.data[i].documentStatus].estado);
                                //            _.set(orders_scope, '[' + i + '].marca', success.data[i].productAntecedent.marca);
                                _.set(orders_scope, '[' + i + '].cliente', success.data[i].receiverAntecedent ? success.data[i].receiverAntecedent.nombreCliente : "");
                                _.set(orders_scope, '[' + i + '].fechaAsignacion', formatDate2(success.data[i].assignmentDate));
                                _.set(orders_scope, '[' + i + '].comuna', success.data[i].receiverAntecedent ? success.data[i].receiverAntecedent.comuna : "");
                                _.set(orders_scope, '[' + i + '].ingeniero', $scope.operatorsArrAsoc[success.data[i].operatorCode]);
                                _.set(orders_scope, '[' + i + '].color', $scope.stateList[success.data[i].documentStatus].color);
                                _.set(orders_scope, '[' + i + '].formType', success.data[i].formType);
                                _.set(orders_scope, '[' + i + '].formSubType', success.data[i].formSubType);
                                _.set(orders_scope, '[' + i + '].fechaCompra', success.data[i].productAntecedent ? formatDate2(success.data[i].productAntecedent.fechaCompra) : null);
                                _.set(orders_scope, '[' + i + ']._id', success.data[i]._id);
                                _.set(orders_scope, '[' + i + '].posGpsFinServicio', success.data[i].assignmentLocation);
                                _.set(orders_scope, '[' + i + '].colorExistePosGPS', success.data[i].assignmentLocation ? "default" : "danger");
                                _.set(orders_scope, '[' + i + '].msgNoPosGPS', success.data[i].assignmentLocation ? "" : " (POSICION GPS NO DETERMINADA)");
                                if (success.data[i].assignmentLocation) {
                                    imarker = success.data[i].assignmentLocation;
                                    $scope.markers.push(imarker);
                                }
                            }
                            $scope.orders = orders_scope;
                            /*|button_mapping|onsuccess|0C90AEF2-D0C1-6BDD-C408-473C557EE902||1876|*/
                            $scope.stopLoading();
                            $scope.ordenesTotal = $scope.orders.length
                        })(success, $scope);
                    },
                    function(error) { // callback to handle request error
                        $scope.stopLoading();
                        $scope.mAlert("Hubo errores al ejecutar la búsqueda: " + error.data.code + " " + error.data.description);
                    },
                    function(notify) { // notify callback, can fire few times
                    });
            };
            /**
             * @function verFicha
             * @param orden
             */
            $scope.verFicha = function(orden) {
                Apperyio.get('userManager').orderId = orden;
                Apperyio.navigateTo("FichaOrden");
            };
            /**
             * @function mostrarMapaEnPantalla
             */
            $scope.mostrarMapaEnPantalla = function() {
                $scope.mostrarMapa = !$scope.mostrarMapa;
                if ($scope.mostrarMapa)
                    $scope.textoBotnVerMapa = "Ocultar Mapa";
                else
                    $scope.textoBotnVerMapa = "Mostrar Mapa";
            };
            /**
             * @function showmsg
             */
            $scope.showmsg = function() {
                alert(1);
            };
            /**
             * @function formatDate2
             * @param fecha
             */
            function formatDate2(fecha) {
                if (!fecha) {
                    return fecha;
                }
                var arrFecha = fecha.split(" ");
                var f = arrFecha[0].split("-");
                return f[2] + "-" + f[1] + "-" + f[0];
            };
            /**
             * @function formatDate3
             * @param dat
             */
            function formatDate3(dat) {
                var fecha = dat.split("T");
                return fecha[0];
            };
        }
    });